// Generated by rstantools.  Do not edit by hand.

/*
    cbq is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    cbq is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with cbq.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by stanc v2.32.2
#include <stan/model/model_header.hpp>
namespace model_cbqrandomb_namespace {
using stan::model::model_base_crtp;
using namespace stan::math;
stan::math::profile_map profiles__;
static constexpr std::array<const char*, 38> locations_array__ =
  {" (found before start of program)",
  " (in 'cbqrandomb', line 23, column 2 to column 17)",
  " (in 'cbqrandomb', line 24, column 2 to column 28)",
  " (in 'cbqrandomb', line 25, column 2 to column 31)",
  " (in 'cbqrandomb', line 28, column 2 to column 11)",
  " (in 'cbqrandomb', line 29, column 2 to column 22)",
  " (in 'cbqrandomb', line 30, column 2 to column 38)",
  " (in 'cbqrandomb', line 33, column 6 to column 79)",
  " (in 'cbqrandomb', line 32, column 18 to line 34, column 5)",
  " (in 'cbqrandomb', line 32, column 4 to line 34, column 5)",
  " (in 'cbqrandomb', line 36, column 6 to column 83)",
  " (in 'cbqrandomb', line 35, column 18 to line 37, column 5)",
  " (in 'cbqrandomb', line 35, column 4 to line 37, column 5)",
  " (in 'cbqrandomb', line 38, column 4 to column 23)",
  " (in 'cbqrandomb', line 31, column 16 to line 39, column 3)",
  " (in 'cbqrandomb', line 31, column 2 to line 39, column 3)",
  " (in 'cbqrandomb', line 13, column 2 to column 8)",
  " (in 'cbqrandomb', line 14, column 2 to column 8)",
  " (in 'cbqrandomb', line 15, column 27 to column 28)",
  " (in 'cbqrandomb', line 15, column 2 to column 32)",
  " (in 'cbqrandomb', line 16, column 9 to column 10)",
  " (in 'cbqrandomb', line 16, column 11 to column 12)",
  " (in 'cbqrandomb', line 16, column 2 to column 16)",
  " (in 'cbqrandomb', line 17, column 2 to column 15)",
  " (in 'cbqrandomb', line 18, column 13 to column 14)",
  " (in 'cbqrandomb', line 18, column 2 to column 16)",
  " (in 'cbqrandomb', line 19, column 2 to column 14)",
  " (in 'cbqrandomb', line 20, column 2 to column 31)",
  " (in 'cbqrandomb', line 23, column 9 to column 10)",
  " (in 'cbqrandomb', line 24, column 9 to column 17)",
  " (in 'cbqrandomb', line 3, column 4 to column 14)",
  " (in 'cbqrandomb', line 7, column 6 to column 36)",
  " (in 'cbqrandomb', line 6, column 11 to line 8, column 5)",
  " (in 'cbqrandomb', line 5, column 6 to column 31)",
  " (in 'cbqrandomb', line 4, column 14 to line 6, column 5)",
  " (in 'cbqrandomb', line 4, column 4 to line 8, column 5)",
  " (in 'cbqrandomb', line 9, column 4 to column 17)",
  " (in 'cbqrandomb', line 2, column 29 to line 10, column 3)"};
template <typename T0__, typename T1__,
          stan::require_all_t<stan::is_stan_scalar<T0__>,
                              stan::is_stan_scalar<T1__>>* = nullptr>
stan::promote_args_t<T0__, T1__>
pald2(const T0__& mu, const T1__& p, std::ostream* pstream__);
template <typename T0__, typename T1__,
          stan::require_all_t<stan::is_stan_scalar<T0__>,
                              stan::is_stan_scalar<T1__>>*>
stan::promote_args_t<T0__, T1__>
pald2(const T0__& mu, const T1__& p, std::ostream* pstream__) {
  using local_scalar_t__ = stan::promote_args_t<T0__, T1__>;
  int current_statement__ = 0;
  static constexpr bool propto__ = true;
  // suppress unused var warning
  (void) propto__;
  local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
  // suppress unused var warning
  (void) DUMMY_VAR__;
  try {
    local_scalar_t__ prob = DUMMY_VAR__;
    current_statement__ = 35;
    if (stan::math::logical_lt(mu, 0)) {
      current_statement__ = 33;
      prob = (p * stan::math::exp((mu * (1 - p))));
    } else {
      current_statement__ = 31;
      prob = (1 - ((1 - p) * stan::math::exp((-mu * p))));
    }
    current_statement__ = 36;
    return prob;
  } catch (const std::exception& e) {
    stan::lang::rethrow_located(e, locations_array__[current_statement__]);
  }
}
#include <stan_meta_header.hpp>
class model_cbqrandomb final : public model_base_crtp<model_cbqrandomb> {
private:
  int N;
  int D;
  Eigen::Matrix<double,-1,1> Y_data__;
  Eigen::Matrix<double,-1,-1> X_data__;
  int N_person;
  std::vector<int> person;
  double offset;
  double q;
  Eigen::Map<Eigen::Matrix<double,-1,1>> Y{nullptr, 0};
  Eigen::Map<Eigen::Matrix<double,-1,-1>> X{nullptr, 0, 0};
public:
  ~model_cbqrandomb() {}
  model_cbqrandomb(stan::io::var_context& context__, unsigned int
                   random_seed__ = 0, std::ostream* pstream__ = nullptr)
      : model_base_crtp(0) {
    int current_statement__ = 0;
    using local_scalar_t__ = double;
    boost::ecuyer1988 base_rng__ =
      stan::services::util::create_rng(random_seed__, 0);
    // suppress unused var warning
    (void) base_rng__;
    static constexpr const char* function__ =
      "model_cbqrandomb_namespace::model_cbqrandomb";
    // suppress unused var warning
    (void) function__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      current_statement__ = 16;
      context__.validate_dims("data initialization", "N", "int",
        std::vector<size_t>{});
      N = std::numeric_limits<int>::min();
      current_statement__ = 16;
      N = context__.vals_i("N")[(1 - 1)];
      current_statement__ = 17;
      context__.validate_dims("data initialization", "D", "int",
        std::vector<size_t>{});
      D = std::numeric_limits<int>::min();
      current_statement__ = 17;
      D = context__.vals_i("D")[(1 - 1)];
      current_statement__ = 18;
      stan::math::validate_non_negative_index("Y", "N", N);
      current_statement__ = 19;
      context__.validate_dims("data initialization", "Y", "double",
        std::vector<size_t>{static_cast<size_t>(N)});
      Y_data__ = Eigen::Matrix<double,-1,1>::Constant(N,
                   std::numeric_limits<double>::quiet_NaN());
      new (&Y) Eigen::Map<Eigen::Matrix<double,-1,1>>(Y_data__.data(), N);
      {
        std::vector<local_scalar_t__> Y_flat__;
        current_statement__ = 19;
        Y_flat__ = context__.vals_r("Y");
        current_statement__ = 19;
        pos__ = 1;
        current_statement__ = 19;
        for (int sym1__ = 1; sym1__ <= N; ++sym1__) {
          current_statement__ = 19;
          stan::model::assign(Y, Y_flat__[(pos__ - 1)],
            "assigning variable Y", stan::model::index_uni(sym1__));
          current_statement__ = 19;
          pos__ = (pos__ + 1);
        }
      }
      current_statement__ = 19;
      stan::math::check_greater_or_equal(function__, "Y", Y, -1);
      current_statement__ = 19;
      stan::math::check_less_or_equal(function__, "Y", Y, 1);
      current_statement__ = 20;
      stan::math::validate_non_negative_index("X", "N", N);
      current_statement__ = 21;
      stan::math::validate_non_negative_index("X", "D", D);
      current_statement__ = 22;
      context__.validate_dims("data initialization", "X", "double",
        std::vector<size_t>{static_cast<size_t>(N), static_cast<size_t>(D)});
      X_data__ = Eigen::Matrix<double,-1,-1>::Constant(N, D,
                   std::numeric_limits<double>::quiet_NaN());
      new (&X) Eigen::Map<Eigen::Matrix<double,-1,-1>>(X_data__.data(), N, D);
      {
        std::vector<local_scalar_t__> X_flat__;
        current_statement__ = 22;
        X_flat__ = context__.vals_r("X");
        current_statement__ = 22;
        pos__ = 1;
        current_statement__ = 22;
        for (int sym1__ = 1; sym1__ <= D; ++sym1__) {
          current_statement__ = 22;
          for (int sym2__ = 1; sym2__ <= N; ++sym2__) {
            current_statement__ = 22;
            stan::model::assign(X, X_flat__[(pos__ - 1)],
              "assigning variable X", stan::model::index_uni(sym2__),
              stan::model::index_uni(sym1__));
            current_statement__ = 22;
            pos__ = (pos__ + 1);
          }
        }
      }
      current_statement__ = 23;
      context__.validate_dims("data initialization", "N_person", "int",
        std::vector<size_t>{});
      N_person = std::numeric_limits<int>::min();
      current_statement__ = 23;
      N_person = context__.vals_i("N_person")[(1 - 1)];
      current_statement__ = 24;
      stan::math::validate_non_negative_index("person", "N", N);
      current_statement__ = 25;
      context__.validate_dims("data initialization", "person", "int",
        std::vector<size_t>{static_cast<size_t>(N)});
      person = std::vector<int>(N, std::numeric_limits<int>::min());
      current_statement__ = 25;
      person = context__.vals_i("person");
      current_statement__ = 26;
      context__.validate_dims("data initialization", "offset", "double",
        std::vector<size_t>{});
      offset = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 26;
      offset = context__.vals_r("offset")[(1 - 1)];
      current_statement__ = 27;
      context__.validate_dims("data initialization", "q", "double",
        std::vector<size_t>{});
      q = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 27;
      q = context__.vals_r("q")[(1 - 1)];
      current_statement__ = 27;
      stan::math::check_greater_or_equal(function__, "q", q, 0);
      current_statement__ = 27;
      stan::math::check_less_or_equal(function__, "q", q, 1);
      current_statement__ = 28;
      stan::math::validate_non_negative_index("beta", "D", D);
      current_statement__ = 29;
      stan::math::validate_non_negative_index("beta_ind", "N_person",
        N_person);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    num_params_r__ = D + N_person + 1;
  }
  inline std::string model_name() const final {
    return "model_cbqrandomb";
  }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = stanc3 v2.32.2",
             "stancflags = --allow-undefined"};
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI,
            stan::require_vector_like_t<VecR>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR>
  log_prob_impl(VecR& params_r__, VecI& params_i__, std::ostream*
                pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    static constexpr const char* function__ =
      "model_cbqrandomb_namespace::log_prob";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(D, DUMMY_VAR__);
      current_statement__ = 1;
      beta = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(D);
      Eigen::Matrix<local_scalar_t__,-1,1> beta_ind =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(N_person, DUMMY_VAR__);
      current_statement__ = 2;
      beta_ind = in__.template read<
                   Eigen::Matrix<local_scalar_t__,-1,1>>(N_person);
      local_scalar_t__ sigma_beta_ind = DUMMY_VAR__;
      current_statement__ = 3;
      sigma_beta_ind = in__.template read_constrain_lb<local_scalar_t__,
                         jacobian__>(0, lp__);
      {
        local_scalar_t__ lik = DUMMY_VAR__;
        current_statement__ = 5;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(beta, 0, 10));
        current_statement__ = 6;
        lp_accum__.add(stan::math::normal_lpdf<propto__>(beta_ind, 0,
                         sigma_beta_ind));
        current_statement__ = 15;
        for (int i = 1; i <= N; ++i) {
          current_statement__ = 9;
          if (stan::math::logical_eq(
                stan::model::rvalue(Y, "Y", stan::model::index_uni(i)), 1)) {
            current_statement__ = 7;
            lik = (pald2(
                     (stan::math::dot_product(
                        stan::model::rvalue(X, "X",
                          stan::model::index_uni(i),
                          stan::model::index_omni()), beta) +
                     stan::model::rvalue(beta_ind, "beta_ind",
                       stan::model::index_uni(
                         stan::model::rvalue(person, "person",
                           stan::model::index_uni(i))))), q, pstream__)
              + offset);
          }
          current_statement__ = 12;
          if (stan::math::logical_eq(
                stan::model::rvalue(Y, "Y", stan::model::index_uni(i)), 0)) {
            current_statement__ = 10;
            lik = ((1 -
              pald2(
                (stan::math::dot_product(
                   stan::model::rvalue(X, "X", stan::model::index_uni(i),
                     stan::model::index_omni()), beta) +
                stan::model::rvalue(beta_ind, "beta_ind",
                  stan::model::index_uni(
                    stan::model::rvalue(person, "person",
                      stan::model::index_uni(i))))), q, pstream__))
              + offset);
          }
          current_statement__ = 13;
          lp_accum__.add(stan::math::log(lik));
        }
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
  }
  template <typename RNG, typename VecR, typename VecI, typename VecVar,
            stan::require_vector_like_vt<std::is_floating_point,
            VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral,
            VecI>* = nullptr, stan::require_vector_vt<std::is_floating_point,
            VecVar>* = nullptr>
  inline void
  write_array_impl(RNG& base_rng__, VecR& params_r__, VecI& params_i__,
                   VecVar& vars__, const bool
                   emit_transformed_parameters__ = true, const bool
                   emit_generated_quantities__ = true, std::ostream*
                   pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    static constexpr bool propto__ = true;
    // suppress unused var warning
    (void) propto__;
    double lp__ = 0.0;
    // suppress unused var warning
    (void) lp__;
    int current_statement__ = 0;
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    constexpr bool jacobian__ = false;
    static constexpr const char* function__ =
      "model_cbqrandomb_namespace::write_array";
    // suppress unused var warning
    (void) function__;
    try {
      Eigen::Matrix<double,-1,1> beta =
        Eigen::Matrix<double,-1,1>::Constant(D,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 1;
      beta = in__.template read<Eigen::Matrix<local_scalar_t__,-1,1>>(D);
      Eigen::Matrix<double,-1,1> beta_ind =
        Eigen::Matrix<double,-1,1>::Constant(N_person,
          std::numeric_limits<double>::quiet_NaN());
      current_statement__ = 2;
      beta_ind = in__.template read<
                   Eigen::Matrix<local_scalar_t__,-1,1>>(N_person);
      double sigma_beta_ind = std::numeric_limits<double>::quiet_NaN();
      current_statement__ = 3;
      sigma_beta_ind = in__.template read_constrain_lb<local_scalar_t__,
                         jacobian__>(0, lp__);
      out__.write(beta);
      out__.write(beta_ind);
      out__.write(sigma_beta_ind);
      if (stan::math::logical_negation(
            (stan::math::primitive_value(emit_transformed_parameters__) ||
            stan::math::primitive_value(emit_generated_quantities__)))) {
        return ;
      }
      if (stan::math::logical_negation(emit_generated_quantities__)) {
        return ;
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, typename VecI,
            stan::require_vector_t<VecVar>* = nullptr,
            stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void
  unconstrain_array_impl(const VecVar& params_r__, const VecI& params_i__,
                         VecVar& vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::deserializer<local_scalar_t__> in__(params_r__, params_i__);
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(D, DUMMY_VAR__);
      current_statement__ = 1;
      stan::model::assign(beta,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(D),
        "assigning variable beta");
      out__.write(beta);
      Eigen::Matrix<local_scalar_t__,-1,1> beta_ind =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(N_person, DUMMY_VAR__);
      current_statement__ = 2;
      stan::model::assign(beta_ind,
        in__.read<Eigen::Matrix<local_scalar_t__,-1,1>>(N_person),
        "assigning variable beta_ind");
      out__.write(beta_ind);
      local_scalar_t__ sigma_beta_ind = DUMMY_VAR__;
      current_statement__ = 3;
      sigma_beta_ind = in__.read<local_scalar_t__>();
      out__.write_free_lb(0, sigma_beta_ind);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  template <typename VecVar, stan::require_vector_t<VecVar>* = nullptr>
  inline void
  transform_inits_impl(const stan::io::var_context& context__, VecVar&
                       vars__, std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    stan::io::serializer<local_scalar_t__> out__(vars__);
    int current_statement__ = 0;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    // suppress unused var warning
    (void) DUMMY_VAR__;
    try {
      current_statement__ = 1;
      context__.validate_dims("parameter initialization", "beta", "double",
        std::vector<size_t>{static_cast<size_t>(D)});
      current_statement__ = 2;
      context__.validate_dims("parameter initialization", "beta_ind",
        "double", std::vector<size_t>{static_cast<size_t>(N_person)});
      current_statement__ = 3;
      context__.validate_dims("parameter initialization", "sigma_beta_ind",
        "double", std::vector<size_t>{});
      int pos__ = std::numeric_limits<int>::min();
      pos__ = 1;
      Eigen::Matrix<local_scalar_t__,-1,1> beta =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(D, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> beta_flat__;
        current_statement__ = 1;
        beta_flat__ = context__.vals_r("beta");
        current_statement__ = 1;
        pos__ = 1;
        current_statement__ = 1;
        for (int sym1__ = 1; sym1__ <= D; ++sym1__) {
          current_statement__ = 1;
          stan::model::assign(beta, beta_flat__[(pos__ - 1)],
            "assigning variable beta", stan::model::index_uni(sym1__));
          current_statement__ = 1;
          pos__ = (pos__ + 1);
        }
      }
      out__.write(beta);
      Eigen::Matrix<local_scalar_t__,-1,1> beta_ind =
        Eigen::Matrix<local_scalar_t__,-1,1>::Constant(N_person, DUMMY_VAR__);
      {
        std::vector<local_scalar_t__> beta_ind_flat__;
        current_statement__ = 2;
        beta_ind_flat__ = context__.vals_r("beta_ind");
        current_statement__ = 2;
        pos__ = 1;
        current_statement__ = 2;
        for (int sym1__ = 1; sym1__ <= N_person; ++sym1__) {
          current_statement__ = 2;
          stan::model::assign(beta_ind, beta_ind_flat__[(pos__ - 1)],
            "assigning variable beta_ind", stan::model::index_uni(sym1__));
          current_statement__ = 2;
          pos__ = (pos__ + 1);
        }
      }
      out__.write(beta_ind);
      local_scalar_t__ sigma_beta_ind = DUMMY_VAR__;
      current_statement__ = 3;
      sigma_beta_ind = context__.vals_r("sigma_beta_ind")[(1 - 1)];
      out__.write_free_lb(0, sigma_beta_ind);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
    }
  }
  inline void
  get_param_names(std::vector<std::string>& names__, const bool
                  emit_transformed_parameters__ = true, const bool
                  emit_generated_quantities__ = true) const {
    names__ = std::vector<std::string>{"beta", "beta_ind", "sigma_beta_ind"};
    if (emit_transformed_parameters__) {}
    if (emit_generated_quantities__) {}
  }
  inline void
  get_dims(std::vector<std::vector<size_t>>& dimss__, const bool
           emit_transformed_parameters__ = true, const bool
           emit_generated_quantities__ = true) const {
    dimss__ = std::vector<std::vector<size_t>>{std::vector<size_t>{static_cast<
                                                                    size_t>(D)},
                std::vector<size_t>{static_cast<size_t>(N_person)},
                std::vector<size_t>{}};
    if (emit_transformed_parameters__) {}
    if (emit_generated_quantities__) {}
  }
  inline void
  constrained_param_names(std::vector<std::string>& param_names__, bool
                          emit_transformed_parameters__ = true, bool
                          emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= D; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= N_person; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta_ind" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "sigma_beta_ind");
    if (emit_transformed_parameters__) {}
    if (emit_generated_quantities__) {}
  }
  inline void
  unconstrained_param_names(std::vector<std::string>& param_names__, bool
                            emit_transformed_parameters__ = true, bool
                            emit_generated_quantities__ = true) const final {
    for (int sym1__ = 1; sym1__ <= D; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta" + '.' +
        std::to_string(sym1__));
    }
    for (int sym1__ = 1; sym1__ <= N_person; ++sym1__) {
      param_names__.emplace_back(std::string() + "beta_ind" + '.' +
        std::to_string(sym1__));
    }
    param_names__.emplace_back(std::string() + "sigma_beta_ind");
    if (emit_transformed_parameters__) {}
    if (emit_generated_quantities__) {}
  }
  inline std::string get_constrained_sizedtypes() const {
    return std::string("[{\"name\":\"beta\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(D) + "},\"block\":\"parameters\"},{\"name\":\"beta_ind\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N_person) + "},\"block\":\"parameters\"},{\"name\":\"sigma_beta_ind\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"}]");
  }
  inline std::string get_unconstrained_sizedtypes() const {
    return std::string("[{\"name\":\"beta\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(D) + "},\"block\":\"parameters\"},{\"name\":\"beta_ind\",\"type\":{\"name\":\"vector\",\"length\":" + std::to_string(N_person) + "},\"block\":\"parameters\"},{\"name\":\"sigma_beta_ind\",\"type\":{\"name\":\"real\"},\"block\":\"parameters\"}]");
  }
  // Begin method overload boilerplate
  template <typename RNG> inline void
  write_array(RNG& base_rng, Eigen::Matrix<double,-1,1>& params_r,
              Eigen::Matrix<double,-1,1>& vars, const bool
              emit_transformed_parameters = true, const bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((D + N_person) + 1);
    const size_t num_transformed = emit_transformed_parameters * (0);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    std::vector<int> params_i;
    vars = Eigen::Matrix<double,-1,1>::Constant(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <typename RNG> inline void
  write_array(RNG& base_rng, std::vector<double>& params_r, std::vector<int>&
              params_i, std::vector<double>& vars, bool
              emit_transformed_parameters = true, bool
              emit_generated_quantities = true, std::ostream*
              pstream = nullptr) const {
    const size_t num_params__ = ((D + N_person) + 1);
    const size_t num_transformed = emit_transformed_parameters * (0);
    const size_t num_gen_quantities = emit_generated_quantities * (0);
    const size_t num_to_write = num_params__ + num_transformed +
      num_gen_quantities;
    vars = std::vector<double>(num_to_write,
             std::numeric_limits<double>::quiet_NaN());
    write_array_impl(base_rng, params_r, params_i, vars,
      emit_transformed_parameters, emit_generated_quantities, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(Eigen::Matrix<T_,-1,1>& params_r, std::ostream* pstream = nullptr) const {
    Eigen::Matrix<int,-1,1> params_i;
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  template <bool propto__, bool jacobian__, typename T_> inline T_
  log_prob(std::vector<T_>& params_r, std::vector<int>& params_i,
           std::ostream* pstream = nullptr) const {
    return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
  }
  inline void
  transform_inits(const stan::io::var_context& context,
                  Eigen::Matrix<double,-1,1>& params_r, std::ostream*
                  pstream = nullptr) const final {
    std::vector<double> params_r_vec(params_r.size());
    std::vector<int> params_i;
    transform_inits(context, params_i, params_r_vec, pstream);
    params_r = Eigen::Map<Eigen::Matrix<double,-1,1>>(params_r_vec.data(),
                 params_r_vec.size());
  }
  inline void
  transform_inits(const stan::io::var_context& context, std::vector<int>&
                  params_i, std::vector<double>& vars, std::ostream*
                  pstream__ = nullptr) const {
    vars.resize(num_params_r__);
    transform_inits_impl(context, vars, pstream__);
  }
  inline void
  unconstrain_array(const std::vector<double>& params_constrained,
                    std::vector<double>& params_unconstrained, std::ostream*
                    pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = std::vector<double>(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
  inline void
  unconstrain_array(const Eigen::Matrix<double,-1,1>& params_constrained,
                    Eigen::Matrix<double,-1,1>& params_unconstrained,
                    std::ostream* pstream = nullptr) const {
    const std::vector<int> params_i;
    params_unconstrained = Eigen::Matrix<double,-1,1>::Constant(num_params_r__,
                             std::numeric_limits<double>::quiet_NaN());
    unconstrain_array_impl(params_constrained, params_i,
      params_unconstrained, pstream);
  }
};
}
using stan_model = model_cbqrandomb_namespace::model_cbqrandomb;
#ifndef USING_R
// Boilerplate
stan::model::model_base&
new_model(stan::io::var_context& data_context, unsigned int seed,
          std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_cbqrandomb_namespace::profiles__;
}
#endif
#endif
